/*
Mod created by FunnyBunnyofDOOM 
AKA: Bunny 
==================================
of the Doomland gaming community

        W                             
       WWW          
       WWW          
      WWWWW         
W     WWWWW     W   
WWW   WWWWW   WWW   
 WWW  WWWWW  WWW    
  WWW  WWW  WWW     
   WWW WWW WWW      
     WWWWWWW        
  WWWW  |  WWWW     
        |           
        |
*/
namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
	using System.Linq;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Objects;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
	using Eco.Gameplay.Interactions;
    using Eco.World;
    using Eco.World.Blocks;
    using Eco.Gameplay.Pipes;
    using Eco.Shared.Services;
    using Eco.Gameplay.Systems.Chat;
    using Eco.Gameplay.Systems.Tooltip;

    [Serialized]
    [Weight(1)]      
    [Currency]
    public partial class DiceItem :
    Item                                     
    {
		
		public override InteractResult OnActRight(InteractionContext context)
        {
            if (context.CarriedItem != null && context.BlockPosition.HasValue)
                return InteractResult.NoOp;
            ToolbarInventory toolbar = context.Player.User.Inventory.Toolbar;
            toolbar.UseStack(context.Player, toolbar.SelectedStack);
            return InteractResult.Success;
        }
		
        public override void OnUsed(Player player, ItemStack itemStack)
        {
            
            
                using (var changes = InventoryChangeSet.New(new Inventory[] { player.User.Inventory, itemStack.Parent }.Distinct(), player.User))
                {
                    
					Random random = new Random();
					int RNG = random.Next(1, 7);
					itemStack.TryModifyStack(player.User, -1);
					ChatManager.ServerMessageToAllLoc(string.Format("{0} Rolled a six sided dice! ({1})",player.User.UILink(),RNG), false, DefaultChatTags.Notifications);
                }
            
        }
		
		public override LocString DisplayName { get { return Localizer.DoStr("Dice"); } } 
        public override LocString DisplayDescription { get { return Localizer.DoStr("It's Dice."); } }

    }
	
	public partial class DiceRecipe : Recipe
    {
        public DiceRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<DiceItem>(),          
            };
            this.Ingredients = new CraftingElement[]
            {
                new CraftingElement<StoneItem>(typeof(BrickProductionEfficiencySkill), 5, BrickProductionEfficiencySkill.MultiplicativeStrategy), 
            };
            this.CraftMinutes = CreateCraftTimeValue(typeof(DiceRecipe), Item.Get<DiceItem>().UILink(), 0.25f, typeof(BrickProductionSpeedSkill));    
            this.Initialize(Localizer.DoStr("Chisel Dice"), typeof(DiceRecipe));

            CraftingComponent.AddRecipe(typeof(MasonryTableObject), this);
        }
    }



[Serialized]
    [Weight(2)]      
    [Currency]                                              
    public partial class DoubleDiceItem :
    Item                                     
    {
		public override InteractResult OnActRight(InteractionContext context)
        {
            if (context.CarriedItem != null && context.BlockPosition.HasValue)
                return InteractResult.NoOp;
            ToolbarInventory toolbar = context.Player.User.Inventory.Toolbar;
            toolbar.UseStack(context.Player, toolbar.SelectedStack);
            return InteractResult.Success;
        }
		
        public override void OnUsed(Player player, ItemStack itemStack)
        {
            
            
                using (var changes = InventoryChangeSet.New(new Inventory[] { player.User.Inventory, itemStack.Parent }.Distinct(), player.User))
                {
                    
					Random random = new Random();
					int RNG = random.Next(1, 7);
					int RNG2 = random.Next(1, 7);
					int TOT = RNG + RNG2;
					itemStack.TryModifyStack(player.User, -1);
					ChatManager.ServerMessageToAllLoc(string.Format("{0} Rolled a {1} and a {2}! ({3})",player.User.UILink(),RNG,RNG2,TOT), false, DefaultChatTags.Notifications);
                }
            
        }
		
		public override LocString DisplayName { get { return Localizer.DoStr("Pair of Dice"); } } 
        public override LocString DisplayDescription { get { return Localizer.DoStr("It's a pair of Dice."); } }

    }
	
	public partial class DoubleDiceRecipe : Recipe
    {
        public DoubleDiceRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<DoubleDiceItem>(),          
            };
            this.Ingredients = new CraftingElement[]
            {
                new CraftingElement<DiceItem>(2), 
            };
            this.CraftMinutes = CreateCraftTimeValue(typeof(DoubleDiceRecipe), Item.Get<DoubleDiceItem>().UILink(), 0.05f, typeof(BrickProductionSpeedSkill));    
            this.Initialize(Localizer.DoStr("Pair Dice"), typeof(DoubleDiceRecipe));

            CraftingComponent.AddRecipe(typeof(MasonryTableObject), this);
        }
    }
	
	[Serialized]
    [Weight(1)]      
    [Currency]                                              
    public partial class FourSidedDiceItem :
    Item                                     
    {
		public override InteractResult OnActRight(InteractionContext context)
        {
            if (context.CarriedItem != null && context.BlockPosition.HasValue)
                return InteractResult.NoOp;
            ToolbarInventory toolbar = context.Player.User.Inventory.Toolbar;
            toolbar.UseStack(context.Player, toolbar.SelectedStack);
            return InteractResult.Success;
        }
		
        public override void OnUsed(Player player, ItemStack itemStack)
        {
            
            
                using (var changes = InventoryChangeSet.New(new Inventory[] { player.User.Inventory, itemStack.Parent }.Distinct(), player.User))
                {
                    
					Random random = new Random();
					int RNG = random.Next(1, 5);
					itemStack.TryModifyStack(player.User, -1);
					ChatManager.ServerMessageToAllLoc(string.Format("{0} Rolled a four sided dice! ({1})",player.User.UILink(),RNG), false, DefaultChatTags.Notifications);
                }
            
        }
		
		public override LocString DisplayName { get { return Localizer.DoStr("Four Sided Dice"); } } 
        public override LocString DisplayDescription { get { return Localizer.DoStr("It's a 4-sided Die."); } }

    }
	
	public partial class FourSidedDiceRecipe : Recipe
    {
        public FourSidedDiceRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<FourSidedDiceItem>(),          
            };
            this.Ingredients = new CraftingElement[]
            {
                new CraftingElement<StoneItem>(typeof(BrickProductionEfficiencySkill), 5, BrickProductionEfficiencySkill.MultiplicativeStrategy), 
            };
            this.CraftMinutes = CreateCraftTimeValue(typeof(FourSidedDiceRecipe), Item.Get<FourSidedDiceItem>().UILink(), 0.25f, typeof(BrickProductionSpeedSkill));    
            this.Initialize(Localizer.DoStr("4-Sided Dice"), typeof(FourSidedDiceRecipe));

            CraftingComponent.AddRecipe(typeof(MasonryTableObject), this);
        }
    }
	
	[Serialized]
    [Weight(1)]      
    [Currency]                                              
    public partial class EightSidedDiceItem :
    Item                                     
    {
		public override InteractResult OnActRight(InteractionContext context)
        {
            if (context.CarriedItem != null && context.BlockPosition.HasValue)
                return InteractResult.NoOp;
            ToolbarInventory toolbar = context.Player.User.Inventory.Toolbar;
            toolbar.UseStack(context.Player, toolbar.SelectedStack);
            return InteractResult.Success;
        }
		
        public override void OnUsed(Player player, ItemStack itemStack)
        {
            
            
                using (var changes = InventoryChangeSet.New(new Inventory[] { player.User.Inventory, itemStack.Parent }.Distinct(), player.User))
                {
                    
					Random random = new Random();
					int RNG = random.Next(1, 9);
					itemStack.TryModifyStack(player.User, -1);
					ChatManager.ServerMessageToAllLoc(string.Format("{0} Rolled an eight sided dice! ({1})",player.User.UILink(),RNG), false, DefaultChatTags.Notifications);
                }
            
        }
		
		public override LocString DisplayName { get { return Localizer.DoStr("Eight Sided Dice"); } } 
        public override LocString DisplayDescription { get { return Localizer.DoStr("It's an 8-sided Die."); } }

    }
	
	public partial class EightSidedDiceRecipe : Recipe
    {
        public EightSidedDiceRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<EightSidedDiceItem>(),          
            };
            this.Ingredients = new CraftingElement[]
            {
                new CraftingElement<StoneItem>(typeof(BrickProductionEfficiencySkill), 5, BrickProductionEfficiencySkill.MultiplicativeStrategy), 
            };
            this.CraftMinutes = CreateCraftTimeValue(typeof(EightSidedDiceRecipe), Item.Get<EightSidedDiceItem>().UILink(), 0.25f, typeof(BrickProductionSpeedSkill));    
            this.Initialize(Localizer.DoStr("8-Sided Dice"), typeof(EightSidedDiceRecipe));

            CraftingComponent.AddRecipe(typeof(MasonryTableObject), this);
        }
    }
	
	[Serialized]
    [Weight(1)]      
    [Currency]                                              
    public partial class TenSidedDiceItem :
    Item                                     
    {
		public override InteractResult OnActRight(InteractionContext context)
        {
            if (context.CarriedItem != null && context.BlockPosition.HasValue)
                return InteractResult.NoOp;
            ToolbarInventory toolbar = context.Player.User.Inventory.Toolbar;
            toolbar.UseStack(context.Player, toolbar.SelectedStack);
            return InteractResult.Success;
        }
		
        public override void OnUsed(Player player, ItemStack itemStack)
        {
            
            
                using (var changes = InventoryChangeSet.New(new Inventory[] { player.User.Inventory, itemStack.Parent }.Distinct(), player.User))
                {
                    
					Random random = new Random();
					int RNG = random.Next(1, 11);
					itemStack.TryModifyStack(player.User, -1);
					ChatManager.ServerMessageToAllLoc(string.Format("{0} Rolled a ten sided dice! ({1})",player.User.UILink(),RNG), false, DefaultChatTags.Notifications);
                }
            
        }
		
		public override LocString DisplayName { get { return Localizer.DoStr("Ten Sided Dice"); } } 
        public override LocString DisplayDescription { get { return Localizer.DoStr("It's a 10-sided Die."); } }

    }
	
	public partial class TenSidedDiceRecipe : Recipe
    {
        public TenSidedDiceRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<TenSidedDiceItem>(),          
            };
            this.Ingredients = new CraftingElement[]
            {
                new CraftingElement<StoneItem>(typeof(BrickProductionEfficiencySkill), 5, BrickProductionEfficiencySkill.MultiplicativeStrategy), 
            };
            this.CraftMinutes = CreateCraftTimeValue(typeof(TenSidedDiceRecipe), Item.Get<TenSidedDiceItem>().UILink(), 0.25f, typeof(BrickProductionSpeedSkill));    
            this.Initialize(Localizer.DoStr("10-Sided Dice"), typeof(TenSidedDiceRecipe));

            CraftingComponent.AddRecipe(typeof(MasonryTableObject), this);
        }
    }
	
	[Serialized]
    [Weight(1)]      
    [Currency]                                              
    public partial class TwelveSidedDiceItem :
    Item                                     
    {
		public override InteractResult OnActRight(InteractionContext context)
        {
            if (context.CarriedItem != null && context.BlockPosition.HasValue)
                return InteractResult.NoOp;
            ToolbarInventory toolbar = context.Player.User.Inventory.Toolbar;
            toolbar.UseStack(context.Player, toolbar.SelectedStack);
            return InteractResult.Success;
        }
		
        public override void OnUsed(Player player, ItemStack itemStack)
        {
            
            
                using (var changes = InventoryChangeSet.New(new Inventory[] { player.User.Inventory, itemStack.Parent }.Distinct(), player.User))
                {
                    
					Random random = new Random();
					int RNG = random.Next(1, 13);
					itemStack.TryModifyStack(player.User, -1);
					ChatManager.ServerMessageToAllLoc(string.Format("{0} Rolled a twelve sided dice! ({1})",player.User.UILink(),RNG), false, DefaultChatTags.Notifications);
                }
            
        }
		
		public override LocString DisplayName { get { return Localizer.DoStr("Twelve Sided Dice"); } } 
        public override LocString DisplayDescription { get { return Localizer.DoStr("It's a 12-sided Die."); } }

    }
	
	public partial class TwelveSidedDiceRecipe : Recipe
    {
        public TwelveSidedDiceRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<TwelveSidedDiceItem>(),          
            };
            this.Ingredients = new CraftingElement[]
            {
                new CraftingElement<StoneItem>(typeof(BrickProductionEfficiencySkill), 5, BrickProductionEfficiencySkill.MultiplicativeStrategy), 
            };
            this.CraftMinutes = CreateCraftTimeValue(typeof(TwelveSidedDiceRecipe), Item.Get<TwelveSidedDiceItem>().UILink(), 0.25f, typeof(BrickProductionSpeedSkill));    
            this.Initialize(Localizer.DoStr("12-Sided Dice"), typeof(TwelveSidedDiceRecipe));

            CraftingComponent.AddRecipe(typeof(MasonryTableObject), this);
        }
    }
	
	[Serialized]
    [Weight(1)]      
    [Currency]                                              
    public partial class TwentySidedDiceItem :
    Item                                     
    {
		public override InteractResult OnActRight(InteractionContext context)
        {
            if (context.CarriedItem != null && context.BlockPosition.HasValue)
                return InteractResult.NoOp;
            ToolbarInventory toolbar = context.Player.User.Inventory.Toolbar;
            toolbar.UseStack(context.Player, toolbar.SelectedStack);
            return InteractResult.Success;
        }
		
        public override void OnUsed(Player player, ItemStack itemStack)
        {
            
            
                using (var changes = InventoryChangeSet.New(new Inventory[] { player.User.Inventory, itemStack.Parent }.Distinct(), player.User))
                {
                    
					Random random = new Random();
					int RNG = random.Next(1, 21);
					itemStack.TryModifyStack(player.User, -1);
					ChatManager.ServerMessageToAllLoc(string.Format("{0} Rolled a twenty sided dice! ({1})",player.User.UILink(),RNG), false, DefaultChatTags.Notifications);
                }
            
        }
		
		public override LocString DisplayName { get { return Localizer.DoStr("Twenty Sided Dice"); } } 
        public override LocString DisplayDescription { get { return Localizer.DoStr("It's a 20-sided Die."); } }

    }
	
	public partial class TwentySidedDiceRecipe : Recipe
    {
        public TwentySidedDiceRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<TwentySidedDiceItem>(),          
            };
            this.Ingredients = new CraftingElement[]
            {
                new CraftingElement<StoneItem>(typeof(BrickProductionEfficiencySkill), 5, BrickProductionEfficiencySkill.MultiplicativeStrategy), 
            };
            this.CraftMinutes = CreateCraftTimeValue(typeof(TwentySidedDiceRecipe), Item.Get<TwentySidedDiceItem>().UILink(), 0.25f, typeof(BrickProductionSpeedSkill));    
            this.Initialize(Localizer.DoStr("20-Sided Dice"), typeof(TwentySidedDiceRecipe));

            CraftingComponent.AddRecipe(typeof(MasonryTableObject), this);
        }
    }
	
	[Serialized]
    [Weight(1)]      
    [Currency]                                              
    public partial class PercentileDiceItem :
    Item                                     
    {
		public override InteractResult OnActRight(InteractionContext context)
        {
            if (context.CarriedItem != null && context.BlockPosition.HasValue)
                return InteractResult.NoOp;
            ToolbarInventory toolbar = context.Player.User.Inventory.Toolbar;
            toolbar.UseStack(context.Player, toolbar.SelectedStack);
            return InteractResult.Success;
        }
		
        public override void OnUsed(Player player, ItemStack itemStack)
        {
            
            
                using (var changes = InventoryChangeSet.New(new Inventory[] { player.User.Inventory, itemStack.Parent }.Distinct(), player.User))
                {
                    
					Random random = new Random();
					int RNG = random.Next(1, 101);
					itemStack.TryModifyStack(player.User, -1);
					ChatManager.ServerMessageToAllLoc(string.Format("{0} Rolled a percentile die! ({1})",player.User.UILink(),RNG), false, DefaultChatTags.Notifications);
                }
            
        }
		
		public override LocString DisplayName { get { return Localizer.DoStr("Percentile Dice"); } } 
        public override LocString DisplayDescription { get { return Localizer.DoStr("Two 10-sided Percentile Die, added up to 100"); } }

    }
	
	public partial class PercentileDiceRecipe : Recipe
    {
        public PercentileDiceRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<PercentileDiceItem>(),          
            };
            this.Ingredients = new CraftingElement[]
            {
                new CraftingElement<TenSidedDiceItem>(2), 
            };
            this.CraftMinutes = CreateCraftTimeValue(typeof(PercentileDiceRecipe), Item.Get<PercentileDiceItem>().UILink(), 0.25f, typeof(BrickProductionSpeedSkill));    
            this.Initialize(Localizer.DoStr("Percentile Dice"), typeof(PercentileDiceRecipe));

            CraftingComponent.AddRecipe(typeof(MasonryTableObject), this);
        }
    }
	
	[Serialized]
    [Weight(250)]      
    [Currency]                                              
    public partial class IronCoinItem :
    Item                                     
    {
		public override InteractResult OnActRight(InteractionContext context)
        {
            if (context.CarriedItem != null && context.BlockPosition.HasValue)
                return InteractResult.NoOp;
            ToolbarInventory toolbar = context.Player.User.Inventory.Toolbar;
            toolbar.UseStack(context.Player, toolbar.SelectedStack);
            return InteractResult.Success;
        }
		
        public override void OnUsed(Player player, ItemStack itemStack)
        {
            
            
                using (var changes = InventoryChangeSet.New(new Inventory[] { player.User.Inventory, itemStack.Parent }.Distinct(), player.User))
                {
                    
					Random random = new Random();
					int RNG = random.Next(0,2);
					string FLIP = "Null";
					if (RNG==1){
						FLIP = "Heads";
					}else{FLIP = "Tails";}					
					ChatManager.ServerMessageToAllLoc(string.Format("{0} Flipped an Iron Coin! ({1})",player.User.UILink(),FLIP), false, DefaultChatTags.Notifications);
                }
            
        }
		
		public override LocString DisplayName { get { return Localizer.DoStr("Iron Coin"); } } 
        public override LocString DisplayDescription { get { return Localizer.DoStr("A dull iron coin"); } }

    }
	
	[RequiresSkill(typeof(BasicSmeltingSkill), 2)]
	public partial class IronCoinRecipe : Recipe
    {
        public IronCoinRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<IronCoinItem>(5),          
            };
            this.Ingredients = new CraftingElement[]
            {
                new CraftingElement<IronIngotItem>(1), 
            };
            this.CraftMinutes = CreateCraftTimeValue(typeof(IronCoinRecipe), Item.Get<IronCoinItem>().UILink(), 0.50f, typeof(BasicSmeltingSpeedSkill));  
            this.Initialize(Localizer.DoStr("Smelt Iron Coin"), typeof(IronCoinRecipe));

            CraftingComponent.AddRecipe(typeof(BloomeryObject), this);
        }
    }
	
	[RequiresSkill(typeof(AlloySmeltingSkill), 2)]
	public partial class IronCoinCastingRecipe : Recipe
    {
        public IronCoinCastingRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<IronCoinItem>(10),          
            };
            this.Ingredients = new CraftingElement[]
            {
                new CraftingElement<IronIngotItem>(1), 
            };
            this.CraftMinutes = CreateCraftTimeValue(typeof(IronCoinCastingRecipe), Item.Get<IronCoinItem>().UILink(), 0.25f, typeof(AlloySmeltingSpeedSkill));  
            this.Initialize(Localizer.DoStr("Cast Iron Coin"), typeof(IronCoinCastingRecipe));

            CraftingComponent.AddRecipe(typeof(BlastFurnaceObject), this);
        }
    }
	
	[Serialized]
    [Weight(250)]      
    [Currency]                                              
    public partial class CopperCoinItem :
    Item                                     
    {
		public override InteractResult OnActRight(InteractionContext context)
        {
            if (context.CarriedItem != null && context.BlockPosition.HasValue)
                return InteractResult.NoOp;
            ToolbarInventory toolbar = context.Player.User.Inventory.Toolbar;
            toolbar.UseStack(context.Player, toolbar.SelectedStack);
            return InteractResult.Success;
        }
		
        public override void OnUsed(Player player, ItemStack itemStack)
        {
            
            
                using (var changes = InventoryChangeSet.New(new Inventory[] { player.User.Inventory, itemStack.Parent }.Distinct(), player.User))
                {
                    
					Random random = new Random();
					int RNG = random.Next(0,2);
					string FLIP = "Null";
					if (RNG==1){
						FLIP = "Heads";
					}else{FLIP = "Tails";}					
					ChatManager.ServerMessageToAllLoc(string.Format("{0} Flipped a Copper Coin! ({1})",player.User.UILink(),FLIP), false, DefaultChatTags.Notifications);
                }
            
        }
		
		public override LocString DisplayName { get { return Localizer.DoStr("Copper Coin"); } } 
        public override LocString DisplayDescription { get { return Localizer.DoStr("A soft shiny copper coin"); } }

    }
	
	[RequiresSkill(typeof(BasicSmeltingSkill), 3)]
	public partial class CopperCoinRecipe : Recipe
    {
        public CopperCoinRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<CopperCoinItem>(5),          
            };
            this.Ingredients = new CraftingElement[]
            {
                new CraftingElement<CopperIngotItem>(1), 
            };
            this.CraftMinutes = CreateCraftTimeValue(typeof(CopperCoinRecipe), Item.Get<CopperCoinItem>().UILink(), 0.50f, typeof(BasicSmeltingSpeedSkill));  
            this.Initialize(Localizer.DoStr("Smelt Copper Coin"), typeof(CopperCoinRecipe));

            CraftingComponent.AddRecipe(typeof(BloomeryObject), this);
        }
    }
	
	[RequiresSkill(typeof(AlloySmeltingSkill), 3)]
	public partial class CopperCoinCastingRecipe : Recipe
    {
        public CopperCoinCastingRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<CopperCoinItem>(10),          
            };
            this.Ingredients = new CraftingElement[]
            {
                new CraftingElement<CopperIngotItem>(1), 
            };
            this.CraftMinutes = CreateCraftTimeValue(typeof(CopperCoinCastingRecipe), Item.Get<CopperCoinItem>().UILink(), 0.25f, typeof(AlloySmeltingSpeedSkill));  
            this.Initialize(Localizer.DoStr("Cast Copper Coin"), typeof(CopperCoinCastingRecipe));

            CraftingComponent.AddRecipe(typeof(BlastFurnaceObject), this);
        }
    }
	
	[Serialized]
    [Weight(250)]      
    [Currency]                                              
    public partial class GoldCoinItem :
    Item                                     
    {
		public override InteractResult OnActRight(InteractionContext context)
        {
            if (context.CarriedItem != null && context.BlockPosition.HasValue)
                return InteractResult.NoOp;
            ToolbarInventory toolbar = context.Player.User.Inventory.Toolbar;
            toolbar.UseStack(context.Player, toolbar.SelectedStack);
            return InteractResult.Success;
        }
		
        public override void OnUsed(Player player, ItemStack itemStack)
        {
            
            
                using (var changes = InventoryChangeSet.New(new Inventory[] { player.User.Inventory, itemStack.Parent }.Distinct(), player.User))
                {
                    
					Random random = new Random();
					int RNG = random.Next(0,2);
					string FLIP = "Null";
					if (RNG==1){
						FLIP = "Heads";
					}else{FLIP = "Tails";}					
					ChatManager.ServerMessageToAllLoc(string.Format("{0} Flipped a Gold Coin! ({1})",player.User.UILink(),FLIP), false, DefaultChatTags.Notifications);
                }
            
        }
		
		public override LocString DisplayName { get { return Localizer.DoStr("Gold Coin"); } } 
        public override LocString DisplayDescription { get { return Localizer.DoStr("A soft shiny golden coin"); } }

    }
	
	[RequiresSkill(typeof(BasicSmeltingSkill), 4)]
	public partial class GoldCoinRecipe : Recipe
    {
        public GoldCoinRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<GoldCoinItem>(5),          
            };
            this.Ingredients = new CraftingElement[]
            {
                new CraftingElement<GoldIngotItem>(1), 
            };
            this.CraftMinutes = CreateCraftTimeValue(typeof(GoldCoinRecipe), Item.Get<GoldCoinItem>().UILink(), 0.50f, typeof(BasicSmeltingSpeedSkill));  
            this.Initialize(Localizer.DoStr("Smelt gold Coin"), typeof(GoldCoinRecipe));

            CraftingComponent.AddRecipe(typeof(BloomeryObject), this);
        }
    }
	
	[RequiresSkill(typeof(AlloySmeltingSkill), 4)]
	public partial class GoldCoinCastingRecipe : Recipe
    {
        public GoldCoinCastingRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<GoldCoinItem>(10),          
            };
            this.Ingredients = new CraftingElement[]
            {
                new CraftingElement<GoldIngotItem>(1), 
            };
            this.CraftMinutes = CreateCraftTimeValue(typeof(GoldCoinCastingRecipe), Item.Get<GoldCoinItem>().UILink(), 0.25f, typeof(AlloySmeltingSpeedSkill));  
            this.Initialize(Localizer.DoStr("Cast Gold Coin"), typeof(GoldCoinCastingRecipe));

            CraftingComponent.AddRecipe(typeof(BlastFurnaceObject), this);
        }
    }


}